#include <SI_EFM8BB1_Register_Enums.h>
#include "InitDevice.h"
#include "hal.h"

void SiLabs_Startup(void) {
	// Disable the watchdog here
	enter_DefaultMode_from_RESET();
}

int pwmChannel = 0;

int exitCondition()
{
	if(getButtonPressedTime()>500)return 1;
	return 0;
}

void demo1() {
	int i, j;
	setPWM(0, RGB_R);
	setPWM(0, RGB_G);
	setPWM(0, RGB_B);
	while (1)
	{
		pwmChannel++;
		if(pwmChannel==3)pwmChannel=0;
			for (j = 0; j < 60; j++) {
				setPWM(pwmChannel, j);
				delay(50);
				if(exitCondition())return;
			}
			setPWM(pwmChannel, 0);
		}
	}
}

void demo2() {
	uint16_t i;
	while(1)
	for (i = 0; i < 60; i++) {
		setPWM(pwmChannel, i);
		if (buttonPressed()) {
			setPWM(pwmChannel, 0);
			pwmChannel++;
			if (pwmChannel > 2)
				pwmChannel = 0;
		}
		if(exitCondition())return;
		delay(10);
	}
}

uint32_t colors[] =
		{ 0x010101, 0x020202, 0x040404, 0x080808, 0x101010, 0x202020 };
int times[] = { 1000, 1000, 500, 1000, 1000, 50 };
void demo4() {
	int i;
	setColor(0x400000);
	delay(1000);
	setColor(0);
	while (!buttonState()) {
	}
	for (i = 0; i < 3; i++) {
		while (buttonState()) {
		}
		if (getButtonPressedTime() > times[i * 2])
			return;
		setColor(colors[i] * 2);
		while (!buttonState()) {
		}
		if (getButtonReleasedTime() < times[i * 2 + 1])
			return;
		setColor(colors[i] * 2 + 1);
	}
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);
	setColor(0x404040);
	delay(300);
	setColor(0);
	delay(300);

}

void main(void) {
		//demo1();
		demo2();
    demo3();
	//demo4();
}
